## getdp 2.4.2

=== CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2013 P. Dular, C. Geuzaine
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@geuz.org>.

cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

# do not warn about non-definition of WIN32 on cygwin
set(CMAKE_LEGACY_CYGWIN_WIN32 0) 

# if CMAKE_BUILD_TYPE is specified use it; otherwise set the default
# build type to "RelWithDebInfo" ("-O2 -g" with gcc) prior to calling
# project()
if(DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose build type")
else(DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose build type")
endif(DEFINED CMAKE_BUILD_TYPE)

# this variable controls the default value of the options which are normally set
# to ON (useful if you want to configure a minimal version of GetDP: e.g. "cmake
# -DDEFAULT=0 -DENABLE_PETSC=1")
set(DEFAULT ON CACHE INTERNAL "Default value for enabled-by-default options")

macro(opt OPTION HELP VALUE)
  option(ENABLE_${OPTION} ${HELP} ${VALUE})
  set(OPT_TEXI "${OPT_TEXI}\n@item ENABLE_${OPTION}\n${HELP} (default: ${VALUE})")
endmacro(opt)

opt(ARPACK "Enable Arpack eigensolver (requires Fortran)" ${DEFAULT})
opt(BLAS_LAPACK "Enable BLAS/Lapack for linear algebra (e.g. for Arpack)" ${DEFAULT})
opt(BUILD_LIB "Enable 'lib' target for building static GetDP library" OFF)
opt(BUILD_SHARED "Enable 'shared' target for building shared GetDP library" OFF)
opt(BUILD_ANDROID "Enable Android NDK library target (experimental)" OFF)
opt(FORTRAN "Enable Fortran (needed for Arpack/Sparskit/Zitsol & Bessel)" ${DEFAULT})
opt(GMSH "Enable Gmsh functions (for field interpolation)" ${DEFAULT})
opt(GSL "Enable GSL functions (for some built-in functions)" ${DEFAULT})
opt(LEGACY "Use legacy assembler (required for actual computations)" ON)
opt(MPI "Enable MPI parallelization (with PETSc/SLEPc)" OFF)
opt(NR "Enable NR functions (if GSL is unavailable)" ${DEFAULT})
opt(NX "Enable proprietary NX extension" OFF)
opt(OPENMP "Enable OpenMP parallelization of some functions (experimental)" OFF)
opt(PETSC "Enable PETSc linear solver" ${DEFAULT})
opt(SLEPC "Enable SLEPc eigensolver" ${DEFAULT})
opt(SPARSKIT "Enable Sparskit solver instead of PETSc (requires Fortran)" ${DEFAULT})
opt(ZITSOL "Enable Zitsol solvers (requires PETSc and Fortran)" OFF)

if(ENABLE_FORTRAN)
  project(getdp CXX C Fortran)
else(ENABLE_FORTRAN)
  project(getdp CXX C)
endif(ENABLE_FORTRAN)

set(GETDP_MAJOR_VERSION 2)
set(GETDP_MINOR_VERSION 4)
set(GETDP_PATCH_VERSION 2)
set(GETDP_EXTRA_VERSION "" CACHE STRING "GetDP extra version string")

set(GETDP_VERSION "${GETDP_MAJOR_VERSION}.${GETDP_MINOR_VERSION}")
set(GETDP_VERSION "${GETDP_VERSION}.${GETDP_PATCH_VERSION}${GETDP_EXTRA_VERSION}")
set(GETDP_SHORT_LICENSE "GNU General Public License")

set(GETDP_API
  ${CMAKE_CURRENT_BINARY_DIR}/Common/GetDPConfig.h 
  ${CMAKE_CURRENT_BINARY_DIR}/Common/GetDPVersion.h
  Legacy/GetDP.h
)

execute_process(COMMAND date "+%Y%m%d" OUTPUT_VARIABLE DATE 
                OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND hostname OUTPUT_VARIABLE HOSTNAME 
                OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND whoami OUTPUT_VARIABLE PACKAGER 
                OUTPUT_STRIP_TRAILING_WHITESPACE)

if(NOT DATE)
  set(DATE "unknown")
endif(NOT DATE)
set(GETDP_DATE "${DATE}")

if(NOT HOSTNAME)
  set(HOSTNAME "unknown")
endif(NOT HOSTNAME)
set(GETDP_HOST "${HOSTNAME}")

if(NOT PACKAGER)
  set(PACKAGER "unknown")
endif(NOT PACKAGER)
set(GETDP_PACKAGER "${PACKAGER}")

if(APPLE)
  set(GETDP_OS "MacOSX")
elseif(CYGWIN)
  set(GETDP_OS "Windows")
else(APPLE)
  set(GETDP_OS "${CMAKE_SYSTEM_NAME}")
endif(APPLE)

include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCXXCompilerFlag)

if(MSVC)
  if(ENABLE_MSVC_STATIC_RUNTIME)
    foreach(VAR
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
      if(${VAR} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${VAR} "${${VAR}}")
      endif(${VAR} MATCHES "/MD")
    endforeach(VAR)
  endif(ENABLE_MSVC_STATIC_RUNTIME)
endif(MSVC)

if(ENABLE_OPENMP)
  find_package(OpenMP)
  if(OPENMP_FOUND)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  endif(OPENMP_FOUND)
endif(ENABLE_OPENMP)

macro(append_getdp_src DIRNAME FILES)
  foreach(FILE ${FILES})
    list(APPEND LIST ${DIRNAME}/${FILE})
  endforeach(FILE)
  set(GETDP_SRC ${GETDP_SRC};${LIST} PARENT_SCOPE)
  set(GETDP_DIRS ${GETDP_DIRS};${DIRNAME} PARENT_SCOPE)
endmacro(append_getdp_src)

macro(find_all_libraries VARNAME LISTNAME PATH SUFFIX)
  set(${VARNAME})
  list(LENGTH ${LISTNAME} NUM_LIST)
  foreach(LIB ${${LISTNAME}})
    find_library(FOUND_LIB ${LIB} PATHS ${PATH} PATH_SUFFIXES ${SUFFIX})
    if(FOUND_LIB)
      list(APPEND ${VARNAME} ${FOUND_LIB})
    endif(FOUND_LIB)
    unset(FOUND_LIB CACHE)
  endforeach(LIB)
  list(LENGTH ${VARNAME} NUM_FOUND_LIBRARIES)
  if(NUM_FOUND_LIBRARIES LESS NUM_LIST)
    set(${VARNAME})
  endif(NUM_FOUND_LIBRARIES LESS NUM_LIST)
endmacro(find_all_libraries)

macro(set_config_option VARNAME STRING)
  set(${VARNAME} TRUE)
  list(APPEND CONFIG_OPTIONS ${STRING})
  message(STATUS "Found " ${STRING})
endmacro(set_config_option)

# check if the machine is 64 bits (this is more reliable than using
# CMAKE_SIZEOF_VOID_P, which does not seem to work e.g. on some Suse
# machines)
check_type_size("void*" SIZEOF_VOID_P)
if(SIZEOF_VOID_P EQUAL 8)
  set_config_option(HAVE_64BIT_SIZE_T "64Bit")
endif(SIZEOF_VOID_P EQUAL 8)

if(ENABLE_BLAS_LAPACK)
  if(MSVC)
    # on Windows with Visual C++ try really hard to find blas/lapack
    # *without* requiring a Fortran compiler: 1) try to find the Intel
    # MKL libs using the standard search path; if not found 2) try to
    # get the reference blas/lapack libs (useful for users with no
    # Fortran compiler and no MKL license, who can just download our
    # precompiled "getdp-dep" package)
    if(HAVE_64BIT_SIZE_T)
      set(MKL_PATH em64t/lib)
    else(HAVE_64BIT_SIZE_T)
      set(MKL_PATH ia32/lib)
    endif(HAVE_64BIT_SIZE_T)
    set(MKL_LIBS_REQUIRED libguide40 mkl_intel_c mkl_intel_thread mkl_core)
    find_all_libraries(LAPACK_LIBRARIES MKL_LIBS_REQUIRED "" ${MKL_PATH})
    if(LAPACK_LIBRARIES)
      set_config_option(HAVE_BLAS "Blas(IntelMKL)")
      set_config_option(HAVE_LAPACK "Lapack(IntelMKL)")
    else(LAPACK_LIBRARIES)
      set(REFLAPACK_LIBS_REQUIRED lapack blas g2c gcc)
      find_all_libraries(LAPACK_LIBRARIES REFLAPACK_LIBS_REQUIRED "" "")
      if(LAPACK_LIBRARIES)
        set_config_option(HAVE_BLAS "Blas(Ref)")
        set_config_option(HAVE_LAPACK "Lapack(Ref)")
      endif(LAPACK_LIBRARIES)
    endif(LAPACK_LIBRARIES)
  elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    # on Linux try to find the Intel MKL without a Fortran compiler
    if(HAVE_64BIT_SIZE_T)
      set(MKL_PATH lib/em64t)
    else(HAVE_64BIT_SIZE_T)
      set(MKL_PATH lib/32)
    endif(HAVE_64BIT_SIZE_T)
    set(MKL_LIBS_REQUIRED mkl_gf_lp64 iomp5 mkl_gnu_thread mkl_core guide pthread)
    find_all_libraries(LAPACK_LIBRARIES MKL_LIBS_REQUIRED "" ${MKL_PATH})
    if(NOT LAPACK_LIBRARIES)
      # match lapack 9.0 on 64bit
      set(MKL_LIBS_REQUIRED mkl_lapack mkl_em64t guide)
      find_all_libraries(LAPACK_LIBRARIES MKL_LIBS_REQUIRED "" ${MKL_PATH})
    endif(NOT LAPACK_LIBRARIES)
    if(LAPACK_LIBRARIES)
      set_config_option(HAVE_BLAS "Blas(IntelMKL)")
      set_config_option(HAVE_LAPACK "Lapack(IntelMKL)")
    else(LAPACK_LIBRARIES)
      # on Linux also try to find ATLAS without a Fortran compiler,
      # because cmake ships with a buggy FindBLAS e.g. on Ubuntu Lucid
      # Lynx
      set(ATLAS_LIBS_REQUIRED lapack f77blas cblas atlas)
      find_all_libraries(LAPACK_LIBRARIES ATLAS_LIBS_REQUIRED "" "")
      if(LAPACK_LIBRARIES)
        set_config_option(HAVE_BLAS "Blas(ATLAS)")
        set_config_option(HAVE_LAPACK "Lapack(ATLAS)")
      else(LAPACK_LIBRARIES)
        # try with generic names
        set(GENERIC_LIBS_REQUIRED lapack blas pthread)
        find_all_libraries(LAPACK_LIBRARIES GENERIC_LIBS_REQUIRED "" "")
        if(LAPACK_LIBRARIES)
          set_config_option(HAVE_BLAS "Blas(Generic)")
          set_config_option(HAVE_LAPACK "Lapack(Generic)")
          find_library(GFORTRAN_LIB gfortran)
          if(GFORTRAN_LIB)
            list(APPEND LAPACK_LIBRARIES ${GFORTRAN_LIB})
          endif(GFORTRAN_LIB)
        endif(LAPACK_LIBRARIES)
      endif(LAPACK_LIBRARIES)
    endif(LAPACK_LIBRARIES)
  elseif(${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
    # on SunOS we know blas and lapack are available in sunperf
    set(LAPACK_FLAGS -library=sunperf)
    set_config_option(HAVE_BLAS "Blas(SubPerf)")
    set_config_option(HAVE_LAPACK "Lapack(SunPerf)")
  elseif(APPLE)
    # on Mac we also know that blas and lapack are available
    set(LAPACK_LIBRARIES "-framework vecLib")
    set_config_option(HAVE_BLAS "Blas(VecLib)")
    set_config_option(HAVE_LAPACK "Lapack(VecLib)")
  endif(MSVC)
  if(NOT HAVE_BLAS OR NOT HAVE_LAPACK)
    # if we haven't found blas and lapack without using the standard
    # cmake tests, do it (this requires a working Fortran compiler)
    enable_language(Fortran)
    find_package(BLAS)
    if(BLAS_FOUND)
      set_config_option(HAVE_BLAS "Blas")
      find_package(LAPACK)
      if(LAPACK_FOUND)
        set_config_option(HAVE_LAPACK "Lapack")
      else(LAPACK_FOUND)
        set(LAPACK_LIBRARIES ${BLAS_LIBRARIES})
      endif(LAPACK_FOUND)
    endif(BLAS_FOUND)
  endif(NOT HAVE_BLAS OR NOT HAVE_LAPACK)
endif(ENABLE_BLAS_LAPACK)

add_subdirectory(Common)
add_subdirectory(Interface)
add_subdirectory(Numeric)

if(ENABLE_LEGACY)
  add_subdirectory(Legacy)
  set_config_option(HAVE_LEGACY "Legacy")
endif(ENABLE_LEGACY)

if(ENABLE_MPI)
   find_package(MPI)
   if(MPI_FOUND)
     set_config_option(HAVE_MPI "MPI")
     list(APPEND EXTERNAL_INCLUDES ${MPI_INCLUDE_DIR})
     list(APPEND EXTERNAL_LIBRARIES ${MPI_LIBRARIES})
     include(CMakeForceCompiler)
     cmake_force_c_compiler(${MPI_C_COMPILER} "MPI C Compiler")
     cmake_force_cxx_compiler(${MPI_CXX_COMPILER} "MPI C++ Compiler")
     cmake_force_fortran_compiler(${MPI_Fortran_COMPILER} "MPI Fortran Compiler")
   endif(MPI_FOUND)
endif(ENABLE_MPI)

if(ENABLE_GMSH)
  find_library(GMSH_LIB Gmsh PATH_SUFFIXES lib)
  find_path(GMSH_INC "Gmsh.h" PATH_SUFFIXES include gmsh include/gmsh)
  if(GMSH_LIB AND GMSH_INC)
    list(APPEND EXTERNAL_LIBRARIES ${GMSH_LIB})
    list(APPEND EXTERNAL_INCLUDES ${GMSH_INC})
    set_config_option(HAVE_GMSH "Gmsh")
  endif(GMSH_LIB AND GMSH_INC)
endif(ENABLE_GMSH)

if(ENABLE_PETSC)
  if(PETSC_DIR)
    set(ENV_PETSC_DIR ${PETSC_DIR})
  else(PETSC_DIR)
    set(ENV_PETSC_DIR $ENV{PETSC_DIR})
  endif(PETSC_DIR)
  if(PETSC_ARCH)
    set(ENV_PETSC_ARCH ${PETSC_ARCH})
  else(PETSC_ARCH)
    set(ENV_PETSC_ARCH $ENV{PETSC_ARCH})
  endif(PETSC_ARCH)
  if(EXISTS ${ENV_PETSC_DIR}/${ENV_PETSC_ARCH}/conf/petscvariables)
    # old-style PETSc installations (using PETSC_DIR and PETSC_ARCH)
    message(STATUS "Using PETSc dir: ${ENV_PETSC_DIR}")
    message(STATUS "Using PETSc arch: ${ENV_PETSC_ARCH}")
    file(STRINGS ${ENV_PETSC_DIR}/${ENV_PETSC_ARCH}/conf/petscvariables 
         PETSC_VARIABLES NEWLINE_CONSUME)
    # find include directories
    list(APPEND EXTERNAL_INCLUDES ${ENV_PETSC_DIR}/include)
    list(APPEND EXTERNAL_INCLUDES ${ENV_PETSC_DIR}/${ENV_PETSC_ARCH}/include)
    string(REGEX MATCH "PACKAGES_INCLUDES = [^\n\r]*" PETSC_PACKAGES_INCLUDES
           ${PETSC_VARIABLES})
    if(PETSC_PACKAGES_INCLUDES)
      string(REPLACE "PACKAGES_INCLUDES = " "" PETSC_PACKAGES_INCLUDES
             ${PETSC_PACKAGES_INCLUDES})

=== Common/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2013 P. Dular, C. Geuzaine
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@geuz.org>.

set(SRC
  ListUtils.cpp
    TreeUtils.cpp avl.cpp
    MallocUtils.cpp
    Message.cpp
    OS.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_getdp_src(Common "${SRC};${HDR}")

=== Interface/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2013 P. Dular, C. Geuzaine
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@geuz.org>.

set(SRC
  ProData.cpp
  ProDefine.cpp
  ProParser.yy.cpp
  ProParser.tab.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(Interface "${SRC};${HDR}")

=== Legacy/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2013 P. Dular, C. Geuzaine
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@geuz.org>.

set(SRC
  MainLegacy.cpp
    F_Analytic.cpp F_BiotSavart.cpp F_Coord.cpp F_ExtMath.cpp
      F_Geometry.cpp F_Interpolation.cpp F_Hysteresis.cpp F_Math.cpp
      F_Misc.cpp F_MultiHar.cpp F_Raytracing.cpp
      F_Gmsh.cpp F_DiffGeom.cpp
    BF_Node.cpp BF_NodeXYZ.cpp BF_Node_2.cpp BF_Node_3.cpp
      BF_Edge.cpp BF_Edge_2.cpp BF_Edge_3.cpp BF_Edge_4.cpp
      BF_Facet.cpp BF_Volume.cpp BF_Region.cpp
      BF_Perpendicular.cpp BF_GroupOfEntities.cpp
    GF_Helmholtz.cpp GF_HelmholtzxForm.cpp
      GF_Laplace.cpp GF_LaplacexForm.cpp
    Gauss_Point.cpp
      Gauss_Line.cpp
      Gauss_Triangle.cpp Gauss_Quadrangle.cpp
      Gauss_Tetrahedron.cpp Gauss_Hexahedron.cpp
      Gauss_Prism.cpp Gauss_Pyramid.cpp
    GeoData.cpp
      GeoEntity.cpp
      GeoNormal.cpp
      GeoTree.cpp
    DofData.cpp
      LinAlg.cpp LinAlg_PETSC.cpp LinAlg_SPARSKIT.cpp
    SolvingAnalyse.cpp SolvingOperations.cpp
      Cal_SolutionErrorRatio.cpp
      Operation_TimeLoopAdaptive.cpp
      Operation_IterativeLoopN.cpp
      Operation_IterativeLinearSolver.cpp
      Operation_IterativeTimeReduction.cpp
      Operation_Update.cpp
      Operation_ChangeOfCoordinates.cpp
	  Operation_PostOperation.cpp
      Treatment_Formulation.cpp
        Get_DofOfElement.cpp
        Get_ConstraintOfElement.cpp
          Treatment_ConstraintByLocalProjection.cpp
          Get_FunctionValue.cpp
          Get_Geometry.cpp
          Get_ElementSource.cpp
        ExtendedGroup.cpp
        Pre_TermOfFemEquation.cpp
          Generate_Network.cpp
        Cal_GalerkinTermOfFemEquation.cpp
        Cal_GlobalTermOfFemEquation.cpp
          Cal_IntegralQuantity.cpp
          Cal_AnalyticIntegration.cpp
          Cal_Quantity.cpp
          Cal_Value.cpp
          Cal_AssembleTerm.cpp
          Cal_PostQuantity.cpp
      MovingBand2D.cpp
      EigenSolve.cpp EigenSolve_ARPACK.cpp EigenSolve_SLEPC.cpp
    Pos_FemInterpolation.cpp
    Pos_Formulation.cpp
      Pos_Print.cpp
        Pos_Element.cpp Pos_Format.cpp Pos_Iso.cpp Pos_Search.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(Legacy "${SRC};${HDR}")

=== Numeric/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2013 P. Dular, C. Geuzaine
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@geuz.org>.

set(SRC
  NumericUtils.cpp
  Adapt.cpp
  Legendre.cpp
  Bessel.cpp
)

if(ENABLE_FORTRAN)
  list(APPEND SRC BesselLib.f)
endif(ENABLE_FORTRAN)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(Numeric "${SRC};${HDR}")

=== contrib/Arpack/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2013 P. Dular, C. Geuzaine
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@geuz.org>.

set(SRC
  sgetv0.f slaqrb.f sstqrb.f ssortc.f ssortr.f sstatn.f sstats.f
    snaitr.f snapps.f snaup2.f snaupd.f snconv.f sneigh.f sngets.f
    ssaitr.f ssapps.f ssaup2.f ssaupd.f ssconv.f sseigt.f ssgets.f
    sneupd.f sseupd.f ssesrt.f
  dgetv0.f dlaqrb.f dstqrb.f dsortc.f dsortr.f dstatn.f dstats.f
    dnaitr.f dnapps.f dnaup2.f dnaupd.f dnconv.f dneigh.f dngets.f
    dsaitr.f dsapps.f dsaup2.f dsaupd.f dsconv.f dseigt.f dsgets.f
    dneupd.f dseupd.f dsesrt.f
  cnaitr.f cnapps.f cnaup2.f cnaupd.f cneigh.f cneupd.f cngets.f
    cgetv0.f csortc.f cstatn.f
  znaitr.f znapps.f znaup2.f znaupd.f zneigh.f zneupd.f zngets.f
    zgetv0.f zsortc.f zstatn.f
  cvout.f dmout.f dvout.f icnteq.f icopy.f iset.f iswap.f
    ivout.f second.f smout.f svout.f zmout.f zvout.f cmout.f
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(contrib/Arpack "${SRC};${HDR}")

=== contrib/Sparskit/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2013 P. Dular, C. Geuzaine
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@geuz.org>.

set(SRC
  Sparskit.cpp
  blas1.f
  blassm.f
  cmkreord.f
  flu.f
  formats.f
  inout.f
  iters.f
  matvec.f
  reordering.f
  unary.f
  ilut.F
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(contrib/Sparskit "${SRC};${HDR}")

=== debian/changelog ===
getdp (2.4.2-1ubuntu1) trusty; urgency=medium

  * Enable mpi on armhf.
  * Enable parallel build.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 23 Dec 2013 18:11:05 +0000

getdp (2.4.2-1build1) trusty; urgency=low

  * Rebuild against latest openmpi

 -- Bhavani Shankar <bhavi@ubuntu.com>  Sun, 22 Dec 2013 15:16:39 +0530

getdp (2.4.2-1) unstable; urgency=low

  * Team upload

  [ Christophe Trophime ]  
  * New upstream release (Closes: #713189)
  * change build system to cmake

  [ Konstantinos Margaritis ]
  * debian/rules: 
    set PETSC_ARCH according to DEB_HOST_ARCH (Closes: #687317)

  [ Sébastien Villemot ]
  * Bump Standards-Version to 3.9.5, no changes needed

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 25 Nov 2013 11:23:20 +0100

=== debian/control ===
Source: getdp
Section: math
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>
Build-Depends: debhelper (>= 9), cmake,
 gfortran, mpi-default-dev,
 libarpack2-dev, libgsl0-dev, libscotchmetis-dev,
 libpetsc3.4.2-dev, libslepc3.4.2-dev, libhdf5-mpi-dev (>= 1.8.8), gmsh,
 texlive, texlive-generic-recommended
#
# comment out to avoid FTBS on sid
#texinfo, install-info
Standards-Version: 3.9.5
Homepage: http://www.geuz.org/getdp
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/getdp/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/getdp/trunk/

Package: getdp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, dpkg (>= 1.15.4) | install-info
Description: general environment for the treatment of discrete problems
 GetDP is a general finite element solver using mixed elements to
 discretize de Rham-type complexes in one, two and three dimensions.
 .
 The main feature of GetDP is the closeness between the input data
 defining discrete problems (written by the user in ASCII data files)
 and the symbolic mathematical expressions of these problems.
 .
 See GetDP's reference manual for a more thorough overview of GetDP's
 capabilities: http://www.geuz.org/getdp

Package: getdp-sparskit
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: general environment for the treatment of discrete problems
 GetDP is a general finite element solver using mixed elements to
 discretize de Rham-type complexes in one, two and three dimensions.
 .
 The main feature of GetDP is the closeness between the input data
 defining discrete problems (written by the user in ASCII data files)
 and the symbolic mathematical expressions of these problems.
 .
 See GetDP's reference manual for a more thorough overview of GetDP's
 capabilities: http://www.geuz.org/getdp
 .
 Getdp is compiled with SPARSKIT support

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR = $(CURDIR)/debian/build
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -n -e 's/\.dfsg.*$$//p')

# PETSC_DIR is the location of PETSc.
export SLEPC_DIR=/usr/lib/slepcdir/3.4.2
export PETSC_DIR=/usr/lib/petscdir/3.4.2

# Fix FTBS on armhf
export PETSC_ARCH=linux-gnu-c-opt
ifeq ("armhf", "$(DEB_HOST_ARCH)")
export PETSC_ARCH=linux-gnueabihf-c-opt
endif
ifeq ("armel", "$(DEB_HOST_ARCH)")
export PETSC_ARCH=linux-gnueabi-c-opt
endif

echo "PETSC_ARCH=" $PETSC_ARCH

%:
	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR) --parallel
export OMPI_MCA_plm_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot

disable_mpi_archs = armel kfreebsd-amd64 kfreebsd-i386 mips mipsel
export LD_LIBRARY_PATH :=  $(CURDIR)/debian/tmp/usr/lib:$(LD_LIBRARY_PATH); 

ifeq (,$(filter $(DEB_HOST_ARCH),$(disable_mpi_archs)))
	extra_flags += \
	-DCMAKE_CXX_FLAGS="-DMPICH_SKIP_MPICXX -DOMPI_SKIP_MPICXX -fopenmp -lmpi -fPIC \
	                   -Wall $(shell dpkg-buildflags --get CXXFLAGS)" \
	-DENABLE_MPI:BOOL=ON
else
	extra_flags += \
	-DCMAKE_CXX_FLAGS="-DMPICH_SKIP_MPICXX -DOMPI_SKIP_MPICXX -fopenmp -fPIC \
	                   -Wall $(shell dpkg-buildflags --get CXXFLAGS)" \
	-DENABLE_MPI:BOOL=OFF
endif

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake --builddirectory=$(BUILDDIR)/petsc --parallel -- $(extra_flags)
	dh_auto_configure --buildsystem=cmake --builddirectory=$(BUILDDIR)/sparskit --parallel -- $(extra_flags) -DENABLE_PETSC=0 -DENABLE_SPARSKIT=1 

override_dh_auto_build:	
	echo "installing getdp"
	dh_auto_build --parallel --builddirectory=$(BUILDDIR)/petsc
	echo "installing getdp-sparskit"
	dh_auto_build --parallel --builddirectory=$(BUILDDIR)/sparskit
	mv $(BUILDDIR)/sparskit/getdp $(BUILDDIR)/sparskit/getdp-sparskit

override_dh_auto_install:
	echo "installing getdp"
	dh_auto_install --paralell  --builddirectory=$(BUILDDIR)/petsc

override_dh_auto_clean:
	rm -rf $(BUILDDIR)/petsc $(BUILDDIR)/sparskit

# Grab the version before +dfsg
DEB_SOURCE_PACKAGE = $(shell dpkg-parsechangelog | grep '^Source:' | cut -f 2 -d ' ')
DEB_UPSTREAM_VERSION = $(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^+]+).*,\1,p' | cut -f 1 -d '-')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -n -e 's/\.dfsg.*$$//p')

get-orig-source:
	set -ex ; \
        mkdir -p tmp ; \
        uscan --force-download --symlink --check-dirname-level 0 --destdir tmp ; \
        tar -C tmp -xzf tmp/$(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION)-source.tgz ; \
	mv tmp/$(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION)-source tmp/$(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION); \
        rm -rf tmp/$(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION)/contrib/Arpack ; \
        GZIP=-9 tar -C tmp -czf \
            $(CURDIR)/$(DEB_SOURCE_PACKAGE)_$(DEB_UPSTREAM_VERSION).orig.tar.gz \
            $(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION) ; \
        rm -rf tmp

=== debian/watch ===
version=3
opts=uversionmangle=s/-([^-]+)/.$1/,dversionmangle=s/\.dfsg$// \
  http://www.geuz.org/getdp/src/ getdp-([\d.-]+)-source\.tgz

## getdp 2.7.0

=== CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2015 P. Dular and C. Geuzaine, University of Liege
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@geuz.org>.

cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

# do not warn about non-definition of WIN32 on cygwin
set(CMAKE_LEGACY_CYGWIN_WIN32 0)

# if CMAKE_BUILD_TYPE is specified use it; otherwise set the default
# build type to "RelWithDebInfo" ("-O2 -g" with gcc) prior to calling
# project()
if(DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose build type")
else(DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose build type")
endif(DEFINED CMAKE_BUILD_TYPE)

# this variable controls the default value of the options which are normally set
# to ON (useful if you want to configure a minimal version of GetDP: e.g. "cmake
# -DDEFAULT=0 -DENABLE_PETSC=1")
set(DEFAULT ON CACHE INTERNAL "Default value for enabled-by-default options")

macro(opt OPTION HELP VALUE)
  option(ENABLE_${OPTION} ${HELP} ${VALUE})
  set(OPT_TEXI "${OPT_TEXI}\n@item ENABLE_${OPTION}\n${HELP} (default: ${VALUE})")
endmacro(opt)

opt(ARPACK "Enable Arpack eigensolver (requires Fortran)" ${DEFAULT})
opt(CONTRIB_ARPACK "Enable Arpack eigensolver from GetDP's contrib folder (requires Fortran)" OFF)
opt(BLAS_LAPACK "Enable BLAS/Lapack for linear algebra (e.g. for Arpack)" ${DEFAULT})
opt(BUILD_LIB "Enable 'lib' target for building static GetDP library" OFF)
opt(BUILD_SHARED "Enable 'shared' target for building shared GetDP library" OFF)
opt(BUILD_DYNAMIC "Enable dynamic GetDP executable (linked with shared lib)" OFF)
opt(BUILD_ANDROID "Enable Android NDK library target (experimental)" OFF)
opt(BUILD_IOS "Enable iOS (ARM) library target (experimental)" OFF)
opt(ONELAB2 "Enable experimental ONELAB-Cloud solver interface" OFF)
opt(FORTRAN "Enable Fortran (needed for Arpack/Sparskit/Zitsol & Bessel)" ${DEFAULT})
opt(GMSH "Enable Gmsh functions (for field interpolation)" ${DEFAULT})
opt(GSL "Enable GSL functions (for some built-in functions)" ${DEFAULT})
opt(LEGACY "Use legacy assembler (required for actual computations)" ON)
opt(MPI "Enable MPI parallelization (with PETSc/SLEPc)" OFF)
opt(MULTIHARMONIC "Enable multi-harmonic support" OFF)
opt(NR "Enable NR functions (if GSL is unavailable)" ${DEFAULT})
opt(NX "Enable proprietary NX extension" OFF)
opt(OCTAVE "Enable Octave functions" ${DEFAULT})
opt(OPENMP "Enable OpenMP parallelization of some functions (experimental)" OFF)
opt(PETSC "Enable PETSc linear solver" ${DEFAULT})
opt(PYTHON "Enable Python functions" ${DEFAULT})
opt(SLEPC "Enable SLEPc eigensolver" ${DEFAULT})
opt(SPARSKIT "Enable Sparskit solver instead of PETSc (requires Fortran)" ${DEFAULT})
opt(ZITSOL "Enable Zitsol solvers (requires PETSc and Fortran)" OFF)

if(ENABLE_FORTRAN)
  project(getdp CXX C Fortran)
else(ENABLE_FORTRAN)
  project(getdp CXX C)
endif(ENABLE_FORTRAN)

set(GETDP_MAJOR_VERSION 2)
set(GETDP_MINOR_VERSION 7)
set(GETDP_PATCH_VERSION 0)
set(GETDP_EXTRA_VERSION "" CACHE STRING "GetDP extra version string")

set(GETDP_VERSION "${GETDP_MAJOR_VERSION}.${GETDP_MINOR_VERSION}")
set(GETDP_VERSION "${GETDP_VERSION}.${GETDP_PATCH_VERSION}${GETDP_EXTRA_VERSION}")
set(GETDP_SHORT_LICENSE "GNU General Public License")

set(GETDP_API
  ${CMAKE_CURRENT_BINARY_DIR}/Common/GetDPConfig.h
  ${CMAKE_CURRENT_BINARY_DIR}/Common/GetDPVersion.h
  Legacy/GetDP.h
)

execute_process(COMMAND date "+%Y%m%d" OUTPUT_VARIABLE DATE
                OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND hostname OUTPUT_VARIABLE HOSTNAME
                OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND whoami OUTPUT_VARIABLE PACKAGER
                OUTPUT_STRIP_TRAILING_WHITESPACE)

if(NOT DATE)
  set(DATE "unknown")
endif(NOT DATE)
set(GETDP_DATE "${DATE}")

if(NOT HOSTNAME)
  set(HOSTNAME "unknown")
endif(NOT HOSTNAME)
set(GETDP_HOST "${HOSTNAME}")

if(NOT PACKAGER)
  set(PACKAGER "unknown")
endif(NOT PACKAGER)
set(GETDP_PACKAGER "${PACKAGER}")

if(APPLE)
  set(GETDP_OS "MacOSX")
elseif(CYGWIN)
  set(GETDP_OS "Windows")
else(APPLE)
  set(GETDP_OS "${CMAKE_SYSTEM_NAME}")
endif(APPLE)

include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCXXCompilerFlag)

if(MSVC)
  if(ENABLE_MSVC_STATIC_RUNTIME)
    foreach(VAR
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
      if(${VAR} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${VAR} "${${VAR}}")
      endif(${VAR} MATCHES "/MD")
    endforeach(VAR)
  endif(ENABLE_MSVC_STATIC_RUNTIME)
endif(MSVC)

if(ENABLE_OPENMP)
  find_package(OpenMP)
  if(OPENMP_FOUND)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  endif(OPENMP_FOUND)
endif(ENABLE_OPENMP)

macro(append_getdp_src DIRNAME FILES)
  foreach(FILE ${FILES})
    list(APPEND LIST ${DIRNAME}/${FILE})
  endforeach(FILE)
  set(GETDP_SRC ${GETDP_SRC};${LIST} PARENT_SCOPE)
  set(GETDP_DIRS ${GETDP_DIRS};${DIRNAME} PARENT_SCOPE)
endmacro(append_getdp_src)

macro(find_all_libraries VARNAME LISTNAME PATH SUFFIX)
  set(${VARNAME})
  list(LENGTH ${LISTNAME} NUM_LIST)
  foreach(LIB ${${LISTNAME}})
    if("${PATH}" STREQUAL "")
      find_library(FOUND_LIB ${LIB} PATH_SUFFIXES ${SUFFIX})
    else("${PATH}" STREQUAL "")
      find_library(FOUND_LIB ${LIB} PATHS ${PATH} NO_DEFAULT_PATH)
    endif("${PATH}" STREQUAL "")
    if(FOUND_LIB)
      list(APPEND ${VARNAME} ${FOUND_LIB})
    endif(FOUND_LIB)
    unset(FOUND_LIB CACHE)
  endforeach(LIB)
  list(LENGTH ${VARNAME} NUM_FOUND_LIBRARIES)
  if(NUM_FOUND_LIBRARIES LESS NUM_LIST)
    set(${VARNAME})
  endif(NUM_FOUND_LIBRARIES LESS NUM_LIST)
endmacro(find_all_libraries)

macro(set_config_option VARNAME STRING)
  set(${VARNAME} TRUE)
  list(APPEND CONFIG_OPTIONS ${STRING})
  message(STATUS "Found " ${STRING})
endmacro(set_config_option)

# check if the machine is 64 bits (this is more reliable than using
# CMAKE_SIZEOF_VOID_P, which does not seem to work e.g. on some Suse
# machines)
check_type_size("void*" SIZEOF_VOID_P)
if(SIZEOF_VOID_P EQUAL 8)
  set_config_option(HAVE_64BIT_SIZE_T "64Bit")
endif(SIZEOF_VOID_P EQUAL 8)

if(ENABLE_BLAS_LAPACK)
  if(BLAS_LAPACK_LIBRARIES)
    # use libs as specified in the BLAS_LAPACK_LIBRARIES variable
    set_config_option(HAVE_BLAS "Blas(Custom)")
    set_config_option(HAVE_LAPACK "Lapack(Custom)")
    set(LAPACK_LIBRARIES ${BLAS_LAPACK_LIBRARIES})
  else(BLAS_LAPACK_LIBRARIES)
    if(MSVC)
      # on Windows with Visual C++ try really hard to find blas/lapack *without*
      # requiring a Fortran compiler: 1) try to find the Intel MKL libs using
      # the standard search path; if not found 2) try to get the reference
      # blas/lapack libs (useful for users with no Fortran compiler and no MKL
      # license, who can just download our precompiled "gmsh-dep" package)
      if(HAVE_64BIT_SIZE_T)
        set(MKL_PATH em64t/lib)
        set(MKL_LIBS_REQUIRED libguide40 mkl_intel_lp64 mkl_intel_thread mkl_core)
      else(HAVE_64BIT_SIZE_T)
        set(MKL_PATH ia32/lib)
        set(MKL_LIBS_REQUIRED libguide40 mkl_intel_c mkl_intel_thread mkl_core)
      endif(HAVE_64BIT_SIZE_T)
      find_all_libraries(LAPACK_LIBRARIES MKL_LIBS_REQUIRED "" ${MKL_PATH})
      if(LAPACK_LIBRARIES)
        set_config_option(HAVE_BLAS "Blas(IntelMKL)")
        set_config_option(HAVE_LAPACK "Lapack(IntelMKL)")
      else(LAPACK_LIBRARIES)
        set(REFLAPACK_LIBS_REQUIRED lapack blas g2c gcc)
        find_all_libraries(LAPACK_LIBRARIES REFLAPACK_LIBS_REQUIRED "" "")
        if(LAPACK_LIBRARIES)
          set_config_option(HAVE_BLAS "Blas(Reference)")
          set_config_option(HAVE_LAPACK "Lapack(Reference)")
        endif(LAPACK_LIBRARIES)
      endif(LAPACK_LIBRARIES)
    elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
      # on Linux try to find the Intel MKL without a Fortran compiler
      if(HAVE_64BIT_SIZE_T)
        set(MKL_PATH lib/em64t)
      else(HAVE_64BIT_SIZE_T)
        set(MKL_PATH lib/32)
      endif(HAVE_64BIT_SIZE_T)
      set(MKL_LIBS_REQUIRED mkl_gf_lp64 iomp5 mkl_gnu_thread mkl_core guide pthread)
      find_all_libraries(LAPACK_LIBRARIES MKL_LIBS_REQUIRED "" ${MKL_PATH})
      if(NOT LAPACK_LIBRARIES)
        # match lapack 9.0 on 64bit
        set(MKL_LIBS_REQUIRED mkl_lapack mkl_em64t guide)
        find_all_libraries(LAPACK_LIBRARIES MKL_LIBS_REQUIRED "" ${MKL_PATH})
      endif(NOT LAPACK_LIBRARIES)
      if(LAPACK_LIBRARIES)
        set_config_option(HAVE_BLAS "Blas(IntelMKL)")
        set_config_option(HAVE_LAPACK "Lapack(IntelMKL)")
      else(LAPACK_LIBRARIES)
        # on Linux also try to find ATLAS without a Fortran compiler, because
        # cmake ships with a buggy FindBLAS e.g. on Ubuntu Lucid Lynx
        set(ATLAS_LIBS_REQUIRED lapack f77blas cblas atlas)
        find_all_libraries(LAPACK_LIBRARIES ATLAS_LIBS_REQUIRED "" "")
        if(LAPACK_LIBRARIES)
          set_config_option(HAVE_BLAS "Blas(ATLAS)")
          set_config_option(HAVE_LAPACK "Lapack(ATLAS)")
        else(LAPACK_LIBRARIES)
          # try with generic names
          set(GENERIC_LIBS_REQUIRED lapack blas pthread)
          find_all_libraries(LAPACK_LIBRARIES GENERIC_LIBS_REQUIRED "" "")
          if(LAPACK_LIBRARIES)
            set_config_option(HAVE_BLAS "Blas(Generic)")
            set_config_option(HAVE_LAPACK "Lapack(Generic)")
            find_library(GFORTRAN_LIB gfortran)
            if(GFORTRAN_LIB)
              list(APPEND LAPACK_LIBRARIES ${GFORTRAN_LIB})
            endif(GFORTRAN_LIB)
          endif(LAPACK_LIBRARIES)
        endif(LAPACK_LIBRARIES)
      endif(LAPACK_LIBRARIES)
    elseif(${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
      # on SunOS we know blas and lapack are available in sunperf
      set(LAPACK_FLAGS -library=sunperf)
      set_config_option(HAVE_BLAS "Blas(SunPerf)")
      set_config_option(HAVE_LAPACK "Lapack(SunPerf)")
    elseif(APPLE)
      # on Mac we also know that blas and lapack are available
      set(LAPACK_LIBRARIES "-llapack -lblas")
      set_config_option(HAVE_BLAS "Blas(VecLib)")
      set_config_option(HAVE_LAPACK "Lapack(VecLib)")
    endif(MSVC)

    if(NOT HAVE_BLAS OR NOT HAVE_LAPACK)
      # if we haven't found blas and lapack check for OpenBlas
      set(OPENBLAS_LIBS_REQUIRED openblas)
      find_all_libraries(LAPACK_LIBRARIES OPENBLAS_LIBS_REQUIRED "" "")
      if(LAPACK_LIBRARIES)
        set_config_option(HAVE_BLAS "Blas(OpenBlas)")
        set_config_option(HAVE_LAPACK "Lapack(OpenBlas)")
        find_library(GFORTRAN_LIB gfortran)
        if(GFORTRAN_LIB)
          list(APPEND LAPACK_LIBRARIES ${GFORTRAN_LIB})
        endif(GFORTRAN_LIB)
      endif(LAPACK_LIBRARIES)  
    endif(NOT HAVE_BLAS OR NOT HAVE_LAPACK)

    if(NOT HAVE_BLAS OR NOT HAVE_LAPACK)
      # if we still haven't found blas and lapack, use the standard cmake tests,
      # which require a working Fortran compiler
      enable_language(Fortran)
      find_package(BLAS)
      if(BLAS_FOUND)
        set_config_option(HAVE_BLAS "Blas")
        find_package(LAPACK)
        if(LAPACK_FOUND)
          set_config_option(HAVE_LAPACK "Lapack")
        else(LAPACK_FOUND)
          set(LAPACK_LIBRARIES ${BLAS_LIBRARIES})
        endif(LAPACK_FOUND)
      endif(BLAS_FOUND)
    endif(NOT HAVE_BLAS OR NOT HAVE_LAPACK)
  endif(BLAS_LAPACK_LIBRARIES)
endif(ENABLE_BLAS_LAPACK)

if(ENABLE_ONELAB2)
  set_config_option(HAVE_ONELAB2 "ONELAB")
  # temporary use ONELAB files from gmsh sources
  find_path(GMSH_SRC "gmsh/CMakeLists.txt" PATH_SUFFIXES src)
  if(GMSH_SRC)

=== Common/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2013 P. Dular, C. Geuzaine
+# GetDP - Copyright (C) 1997-2015 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@geuz.org>.

=== Interface/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2015 P. Dular and C. Geuzaine, University of Liege
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@geuz.org>.

set(SRC
  ProData.cpp
  ProDefine.cpp
  ProParser.yy.cpp
  ProParser.tab.cpp
  MacroManager.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(Interface "${SRC};${HDR}")

=== Legacy/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2013 P. Dular, C. Geuzaine
+# GetDP - Copyright (C) 1997-2015 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@geuz.org>.
@@ -8,7 +8,7 @@
     F_Analytic.cpp F_BiotSavart.cpp F_Coord.cpp F_ExtMath.cpp
       F_Geometry.cpp F_Interpolation.cpp F_Hysteresis.cpp F_Math.cpp
       F_Misc.cpp F_MultiHar.cpp F_Raytracing.cpp
-      F_Gmsh.cpp F_DiffGeom.cpp
+      F_Gmsh.cpp F_DiffGeom.cpp F_Octave.cpp F_Python.cpp
     BF_Node.cpp BF_NodeXYZ.cpp BF_Node_2.cpp BF_Node_3.cpp
       BF_Edge.cpp BF_Edge_2.cpp BF_Edge_3.cpp BF_Edge_4.cpp
       BF_Facet.cpp BF_Volume.cpp BF_Region.cpp

=== Numeric/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2013 P. Dular, C. Geuzaine
+# GetDP - Copyright (C) 1997-2015 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@geuz.org>.

=== contrib/Arpack/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2013 P. Dular, C. Geuzaine
+# GetDP - Copyright (C) 1997-2015 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@geuz.org>.

=== contrib/Sparskit/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2013 P. Dular, C. Geuzaine
+# GetDP - Copyright (C) 1997-2015 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@geuz.org>.

=== debian/changelog ===
getdp (2.7.0-2) unstable; urgency=medium

  * Don't use -march and -mtune in g++ flags.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 12 Feb 2016 22:48:08 +0000

getdp (2.7.0-1) unstable; urgency=medium

  * Team upload.

  [ Mattia Rizzolo ]
  * Imported Upstream version 2.7.0.
  * Refresh patches and remove disabled ones.
  * Remove useless debian/dirs file.
  * Remove useless README.source file.  This is source format 3.0 (quilt),
    this is not the place to explain how to use quilt.
  * Rename debian/upstream to debian/upstream/metadata.
  * Run wrap-and-sort.
  * Bump debhelper compat level to 9.
  * Install README.txt in all binary packages.
  * debian/rules: semplify it.
  * debian/control:
    + Switch to unversioned Build-Depends on petsc-dev and slepc-dev.
    + Build-Depend on libgsl-dev instead of libgsl0-dev for the GSL2 transition.
    + Move the packaging to git, update Vcs-Git and Vcs-Browser.
    + Bump Standards-Version to 3.9.7, no changes needed.
    + Remove dpkg >= 1.15.4 from getdp Depends, that version is old enough.

  [ Christophe Trophime ]
  * Add python support
  * debian/control:
    + remove lib[scotch]metis, gmsh[-tetgen], libgmsh[-tetgen]-dev,
      libhdf5-mpi-dev from Build-Depends.  Closes: #755973
    + update Build-Depends for the new upstream.

  [Andreas Tille]
  * debian/upstream: add reference.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 12 Feb 2016 19:59:04 +0000

=== debian/control ===
Source: getdp
Section: math
Priority: extra
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>,
Build-Depends:
 cmake,
 debhelper (>= 9),
 gfortran,
 libarpack2-dev,
 libgsl-dev,
 mpi-default-dev,
 petsc-dev,
 python-dev (>= 2.6.6-3~),
 slepc-dev,
 swig2.0,
 texlive,
 texlive-generic-recommended,
Standards-Version: 3.9.7
Homepage: http://www.geuz.org/getdp
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/getdp.git
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/getdp.git

Package: getdp
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: general environment for the treatment of discrete problems
 GetDP is a general finite element solver using mixed elements to
 discretize de Rham-type complexes in one, two and three dimensions.
 .
 The main feature of GetDP is the closeness between the input data
 defining discrete problems (written by the user in ASCII data files)
 and the symbolic mathematical expressions of these problems.
 .
 See GetDP's reference manual for a more thorough overview of GetDP's
 capabilities: http://www.geuz.org/getdp

Package: getdp-sparskit
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: general environment for the treatment of discrete problems
 GetDP is a general finite element solver using mixed elements to
 discretize de Rham-type complexes in one, two and three dimensions.
 .
 The main feature of GetDP is the closeness between the input data
 defining discrete problems (written by the user in ASCII data files)
 and the symbolic mathematical expressions of these problems.
 .
 See GetDP's reference manual for a more thorough overview of GetDP's
 capabilities: http://www.geuz.org/getdp
 .
 Getdp is compiled with SPARSKIT support

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR_PETSC = $(CURDIR)/debian/build/petsc
BUILDDIR_SPARSKIT = $(CURDIR)/debian/build/sparskit

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic -O3
export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic -O3
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export OMPI_MCA_plm_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure --builddirectory=$(BUILDDIR_PETSC) -O--parallel -- -DENABLE_MPI:BOOL=ON -DENABLE_PETSC=1 -DENABLE_SPARSKIT=0
	dh_auto_configure --builddirectory=$(BUILDDIR_SPARSKIT) -O--parallel -- -DENABLE_MPI:BOOL=ON -DENABLE_PETSC=0 -DENABLE_SPARSKIT=1
	sed -i 's/-lpthread/-lgfortran -lpthread/' debian/build/*/CMakeFiles/getdp.dir/link.txt


override_dh_auto_build:
	@echo "Building getdp"
	dh_auto_build -O--parallel --builddirectory=$(BUILDDIR_PETSC)
	@echo "Building getdp-sparskit"
	dh_auto_build -O--parallel --builddirectory=$(BUILDDIR_SPARSKIT)
	mv $(BUILDDIR_SPARSKIT)/getdp $(BUILDDIR_SPARSKIT)/getdp-sparskit

override_dh_auto_install:
	@echo "Installing getdp"
	dh_auto_install -O--parallel --builddirectory=$(BUILDDIR_PETSC)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR_PETSC) $(BUILDDIR_SPARSKIT)

override_dh_installdocs:
	dh_installdocs --all README.txt

# Grab the version before +dfsg
DEB_SOURCE_PACKAGE = $(shell dpkg-parsechangelog | grep '^Source:' | cut -f 2 -d ' ')
DEB_UPSTREAM_VERSION = $(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^+]+).*,\1,p' | cut -f 1 -d '-')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -n -e 's/\.dfsg.*$$//p')
get-orig-source:
	set -ex ; \
        mkdir -p tmp ; \
        uscan --force-download --symlink --check-dirname-level 0 --destdir tmp ; \
        tar -C tmp -xzf tmp/$(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION)-source.tgz ; \
	mv tmp/$(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION)-source tmp/$(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION); \
        rm -rf tmp/$(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION)/contrib/Arpack ; \
        GZIP=-9 tar -C tmp -czf \
            $(CURDIR)/$(DEB_SOURCE_PACKAGE)_$(DEB_UPSTREAM_VERSION).orig.tar.gz \
            $(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION) ; \
        rm -rf tmp
